VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cInventory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3D3D19B9023A"
'##ModelId=3D4A935F00FA
'<CAMH>****************************************************************************************
'* Module : Inventory
'* Date   : 26/09/02
'* Author : mauricem
'*$Archive: /Projects/OasysV2/VB/InventoryBO/Inventory.cls $
'**********************************************************************************************
'* Summary:Provides all access to the Stock Item Inventory
'**********************************************************************************************
'* $Author: Damians $  $Date: 28/05/04 15:10 $ $Revision: 22 $
'* Versions:
'* 26/09/02    mauricem
'*             Header added.
'</CAMH>***************************************************************************************
Option Base 0
Option Explicit

Const MODULE_NAME As String = "Inventory"

Const FIELD_INTERFACE_IFIELD = 1

Const NOT_LOADED As Long = -1
Const LOADED As Long = 0
Const EDITED As Long = 1
Const Deleted As Long = 2

Implements IBo
Implements ISysBo

Private m_oSession As Session
'##ModelId=3D3D19FF010E
Private mPartCode As String '

'##ModelId=3D3D1A060208
Private mDescription As String '

'##ModelId=3D3D2FAE0028
Private mVATRate As Long '

'##ModelId=3D3D33D501C2
Private mSupplierUnitCode As String '

'##ModelId=3D3D33F40334
Private mSupplierNo As String '

'##ModelId=3D3D33F902F8
Private mSupplierPartCode As String '

'##ModelId=3D3D33C0008C
Private mSupplierPackSize As Double

'##ModelId=3D4A897700E6
Private mNormalSellPrice As Currency

'##ModelId=3D4A897C01C2
Private mPriorSellPrice As Currency '

'##ModelId=3D3EBCF6024E
Private mCostPrice As Double

'##ModelId=3D3D34CC029E
Private mLastSold As Date

'##ModelId=3D3D34E0000A
Private mLastReceived As Date

'##ModelId=3D3D34E80244
Private mLastOrdered As Date

'##ModelId=3D3EBD00032A
Private mPriceEffectiveDate As Date

'##ModelId=3D3EBD160186
Private mDateCreated As Date

'##ModelId=3D4A8CDB00DC
Private mDateObsolete As Date

'##ModelId=3D4A8CD30244
Private mDateDeleted As Date

'##ModelId=3D3D1A0B0082
Private mQuantityAtHand As Double

'##ModelId=3D3EBC5E0118
Private mQuantityOnOrder As Double

'##ModelId=3D3D2FDE02C6
Private mMinQuantity As Double

'##ModelId=3D3D2FE40136
Private mMaxQuantity As Double

'##ModelId=3D3D2FEF0348
Private mStatus As String

'##ModelId=3D4A90450316
Private mRelatedItemSingle As Boolean

'##ModelId=3D4A905E0122
Private mRelatedNoItems As Long

'##ModelId=3D4A907F001E
Private mCatchAll As Boolean

'##ModelId=3D3EBD0A00FA
Private mItemObsolete As Boolean

'##ModelId=3D3EBD11030C
Private mItemDeleted As Boolean

'##ModelId=3D4A8D27029E
Private mItemTagged As Boolean

'##ModelId=3D3D1A1300D2
Private mWarranty As Boolean


'##ModelId=3D3D2F6F02BC
Private mEAN As Long

Private mValueSoldYesterday As Currency
Private mUnitsSoldYesterday As Long

Private mValueSoldThisWeek As Currency
Private mUnitsSoldThisWeek As Long

Private mValueSoldLastWeek As Currency
Private mUnitsSoldLastWeek As Long

Private mValueSoldThisPeriod As Currency
Private mUnitsSoldThisPeriod As Long

Private mValueSoldLastPeriod As Currency
Private mUnitsSoldLastPeriod As Long

Private mValueSoldThisYear As Currency
Private mUnitsSoldThisYear As Long

Private mValueSoldLastYear As Currency
Private mUnitsSoldLastYear As Long

'##ModelId=3D4A936703A2
Private mDaysOutStockPeriod As Long

'##ModelId=3D4A93AE0190
Private mAverageWeeklySales As Currency

'##ModelId=3D4A972F0258
Private mDateFirstStock As Date

'##ModelId=3D4A9742006E
Private mNoWeeksUpdated As Long

'##ModelId=3D4A9749008C
Private mWeeklyUpdate As Boolean

'##ModelId=3D4A9755029E
Private mConfidentWeeklyAverage As Boolean

'##ModelId=3D4A976700F0
Private mUnitsSoldWeek(14) As Long

'##ModelId=3D4A976F0096
Private mCalcDay(14) As Long

Private mWeight As Double

Private mShortDescription             As String
Private mNoOfPriceChangeRecs          As Long
Private mNonStockItem                 As Boolean
Private mDaysOutOfStock               As Long
Private mAvgWeeklySales               As Currency
Private mSOQv4Weeks                   As Long
Private mSOQv13Weeks                  As Long
Private mSOQvLastWeek                 As Long
Private mOrderPlacedThisSOQ           As Boolean
Private mUnitsReceivedToday           As Long
Private mValueReceivedToday           As Currency
Private mActivityToday                As Boolean
Private mUnitsInOpenReturns           As Long
Private mValueInOpenReturns           As Currency
Private mHOCheckDigit                 As String
Private mNoOfSmallLabels              As Long
Private mUnitsStandingOrders          As String
Private mValueStandingOrders          As Long
Private mStandingOrderDay1            As String
Private mStandingOrderDay2            As String
Private mStandingOrderDay3            As String
Private mNoOfMediumLabels             As Long
Private mNoOfLargeLabels              As Long
Private mItemVolume                   As Double
Private mDoNotOrder                   As Boolean
Private mAlternateSupplier            As String
Private mInitialOrderDate             As Date
Private mFinalOrderDate               As Date
Private mPromotionalMinimum           As Long
Private mPromotionalMinimumStart      As Date
Private mPromotionalMinimumEnd        As Date
Private mPromotionalMinimumMCP        As String
Private mSpacemanDisplayFactor        As Long
Private mDateMinimumLastChanged       As Date
Private mParticipatingInMCP           As Boolean
Private mItemTagType                  As String
Private mProductEquivalentDescription As String
Private mHierCategoryGroup            As String
Private mRetailPriceEventNo           As String
Private mRetailPricePriority          As String
Private mEquivalentPriceMult          As Double
Private mEquivalentPriceUnit          As String
Private mMarkDownQuantity             As Long
Private mWriteOffQuantity             As Long
Private mAutoApplyPriceChanges        As Boolean
Private mAllowAdjustments             As String
Private mSavedSupplier                As String
Private mWebOrderQuantity             As Long

Private mBallastItem    As Boolean 'WIX1225

Private mWEEERate       As String
Private mWEEESequence   As String
Private mPRFSKU         As String 'WIX1337-use separate PRF SKU to look up charge

Private moRowSel As IRowSelector

Private moLoadRow As IRowSelector

'##ModelId=3D3FC29502BC
Public Sub Create()
End Sub


'##ModelId=3D3D58D90136
Public Sub GetList()
End Sub

'##ModelId=3D3D58E10294
Public Sub MatchSearch()
End Sub

'##ModelId=3D3D58EF003C
Public Sub SuppliersForItem()
End Sub

'##ModelId=3D3FC2790050
Public Sub AddSupplier()
End Sub

'##ModelId=3D3FC282001E
Public Sub DeleteSupplier()
End Sub

'##ModelId=3D3D3C7702C6
Public Sub UpdatePrice(NewPrice As Currency, EffectiveDate As Variant)
End Sub

'##ModelId=3D3FC289033E
Public Sub ListOrders()
End Sub

'##ModelId=3D3FC25D0230
Public Sub ReserveItem()
End Sub

'##ModelId=3D3FC264032A
Public Sub SellItem()
End Sub

'##ModelId=3D3FC26902BC
Public Sub ReceiveItem()
End Sub

'##ModelId=3D3FC272010E
Public Sub OrderItem()
End Sub

'##ModelId=3D3FC28D0046
Public Sub ListStockMovement()
End Sub

'##ModelId=3D58DDD902D0
Public Property Let PartCode(ByVal Value As String)
    mPartCode = Value
End Property

'##ModelId=3D58DDDA02C6
Public Property Get PartCode() As String
    PartCode = mPartCode
End Property

'##ModelId=3D58DDDB0172
Public Property Let Description(ByVal Value As String)
    mDescription = Value
End Property

'##ModelId=3D58DDDC02E4
Public Property Get Description() As String
    Description = mDescription
End Property

'##ModelId=3D58DDDD0122
Public Property Let QuantityAtHand(ByVal Value As Double)
    mQuantityAtHand = Value
End Property

'##ModelId=3D58DDDE0118
Public Property Get QuantityAtHand() As Double
    QuantityAtHand = mQuantityAtHand
End Property

'##ModelId=3D58DDDF006E
Public Property Let QuantityOnOrder(ByVal Value As Double)
    mQuantityOnOrder = Value
End Property

'##ModelId=3D58DDE00028
Public Property Get QuantityOnOrder() As Double
    QuantityOnOrder = mQuantityOnOrder
End Property

Public Property Let WEEERate(ByVal Value As String)
    mWEEERate = Value
End Property

'##ModelId=3D58DDDC02E4
Public Property Get WEEERate() As String
    WEEERate = mWEEERate
End Property

Public Property Let WEEESequence(ByVal Value As String)
    mWEEESequence = Value
End Property

'##ModelId=3D58DDDC02E4
Public Property Get WEEESequence() As String
    WEEESequence = mWEEESequence
End Property

'WIX1337- Store Product Recycling Fund as separate SKU
Public Property Let PRFSKU(ByVal Value As String)
    mPRFSKU = Value
End Property

'WIX1337- Store Product Recycling Fund as separate SKU
Public Property Get PRFSKU() As String
    PRFSKU = mPRFSKU
End Property

Public Function RecordWebOrder(ByVal strPartCode As String, ByVal lngOrderQuantity As Long)

Dim oRow As IRow
            
    Call AddLoadFilter(CMP_EQUAL, FID_INVENTORY_PartCode, strPartCode)
    
    Call AddLoadField(FID_INVENTORY_PartCode)
    Call AddLoadField(FID_INVENTORY_WebOrderQuantity)
    
    Call LoadMatches
    mWebOrderQuantity = mWebOrderQuantity + lngOrderQuantity

    'Save updated fields back to Database
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    Call oRow.Add(GetField(FID_INVENTORY_PartCode))
    Call oRow.Add(GetField(FID_INVENTORY_WebOrderQuantity))

    Call m_oSession.Database.SavePartialBo(Me, oRow)
    Set oRow = Nothing
    
End Function

Public Function RecordWebOrderTaken(ByVal strPartCode As String, ByVal lngUsedQuantity As Long)

Dim oRow As IRow
            
    Call AddLoadFilter(CMP_EQUAL, FID_INVENTORY_PartCode, strPartCode)
    
    Call AddLoadField(FID_INVENTORY_PartCode)
    Call AddLoadField(FID_INVENTORY_WebOrderQuantity)
    
    Call LoadMatches
    mWebOrderQuantity = mWebOrderQuantity - lngUsedQuantity
    If (mWebOrderQuantity < 0) Then mWebOrderQuantity = 0

    'Save updated fields back to Database
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    Call oRow.Add(GetField(FID_INVENTORY_PartCode))
    Call oRow.Add(GetField(FID_INVENTORY_WebOrderQuantity))

    Call m_oSession.Database.SavePartialBo(Me, oRow)
    Set oRow = Nothing

End Function

Public Property Get WebOrderQuantity() As Long
    WebOrderQuantity = mWebOrderQuantity
End Property

'##ModelId=3D58DDE80302
Public Property Let EAN(ByVal Value As Long)
    mEAN = Value
End Property

'##ModelId=3D58DDE902F8
Public Property Get EAN() As Long
    EAN = mEAN
End Property

'##ModelId=3D58DDEC0046
Public Property Let Warranty(ByVal Value As Boolean)
    mWarranty = Value
End Property

'##ModelId=3D58DDED006E
Public Property Get Warranty() As Boolean
    Warranty = mWarranty
End Property

'##ModelId=3D58DDED0302
Public Property Let VATRate(ByVal Value As Long)
    mVATRate = Value
End Property

'##ModelId=3D58DDEE032A
Public Property Get VATRate() As Long
    VATRate = mVATRate
End Property

'##ModelId=3D58DDFE01D6
Public Property Let MinQuantity(ByVal Value As Double)
    mMinQuantity = Value
End Property

'##ModelId=3D58DE00000A
Public Property Get MinQuantity() As Double
    MinQuantity = mMinQuantity
End Property

'##ModelId=3D58DE0003DE
Public Property Let MaxQuantity(ByVal Value As Double)
    mMaxQuantity = Value
End Property

'##ModelId=3D58DE020212
Public Property Get MaxQuantity() As Double
    MaxQuantity = mMaxQuantity
End Property

'##ModelId=3D58DE030208
Public Property Let Status(ByVal Value As String)
    mStatus = Value
End Property

'##ModelId=3D58DE05006E
Public Property Get Status() As String
    Status = mStatus
End Property

'##ModelId=3D58DE0A0370
Public Property Let SupplierPackSize(ByVal Value As Double)
    mSupplierPackSize = Value
End Property

'##ModelId=3D58DE0C0168
Public Property Get SupplierPackSize() As Double
    SupplierPackSize = mSupplierPackSize
End Property

'##ModelId=3D58DE140226
Public Property Let SupplierUnitCode(ByVal Value As String)
    mSupplierUnitCode = Value
End Property

'##ModelId=3D58DE16008C
Public Property Get SupplierUnitCode() As String
    SupplierUnitCode = mSupplierUnitCode
End Property

'##ModelId=3D58DE2400C8
Public Property Let SupplierNo(ByVal Value As String)
    mSupplierNo = Value
End Property

'##ModelId=3D58DE250384
Public Property Get SupplierNo() As String
    SupplierNo = mSupplierNo
End Property

'##ModelId=3D58DE2603B6
Public Property Let SupplierPartCode(ByVal Value As String)
    mSupplierPartCode = Value
End Property

'##ModelId=3D58DE2802C6
Public Property Get SupplierPartCode() As String
    SupplierPartCode = mSupplierPartCode
End Property

'##ModelId=3D58DE3500AA
Public Property Let NormalSellPrice(ByVal Value As Currency)
    mNormalSellPrice = Value
End Property

'##ModelId=3D58DE370028
Public Property Get NormalSellPrice() As Currency
    NormalSellPrice = mNormalSellPrice
End Property

'##ModelId=3D58DE38008C
Public Property Let PriorSellPrice(ByVal Value As Currency)
    mPriorSellPrice = Value
End Property

'##ModelId=3D58DE3A000A
Public Property Get PriorSellPrice() As Currency
    PriorSellPrice = mPriorSellPrice
End Property

'##ModelId=3D58DE4800E6
Public Property Let LastSold(ByVal Value As Date)
    mLastSold = Value
End Property

'##ModelId=3D58DE4A021C
Public Property Get LastSold() As Date
    LastSold = mLastSold
End Property

'##ModelId=3D58DE4B038E
Public Property Let LastReceived(ByVal Value As Date)
    mLastReceived = Value
End Property

'##ModelId=3D58DE4E00DC
Public Property Get LastReceived() As Date
    LastReceived = mLastReceived
End Property

'##ModelId=3D58DE4F024E
Public Property Let LastOrdered(ByVal Value As Date)
    mLastOrdered = Value
End Property

'##ModelId=3D58DE5103B6
Public Property Get LastOrdered() As Date
    LastOrdered = mLastOrdered
End Property

'##ModelId=3D58DE5D01AE
Public Property Let CostPrice(ByVal Value As Double)
    mCostPrice = Value
End Property

'##ModelId=3D58DE5F0208
Public Property Get CostPrice() As Double
    CostPrice = mCostPrice
End Property

'##ModelId=3D58DE600348
Public Property Let PriceEffectiveDate(ByVal Value As Date)
    mPriceEffectiveDate = Value
End Property

'##ModelId=3D58DE6203D4
Public Property Get PriceEffectiveDate() As Date
    PriceEffectiveDate = mPriceEffectiveDate
End Property

'##ModelId=3D58DE64012C
Public Property Let ItemObsolete(ByVal Value As Boolean)
    mItemObsolete = Value
End Property

'##ModelId=3D58DE660262
Public Property Get ItemObsolete() As Boolean
    ItemObsolete = mItemObsolete
End Property

'##ModelId=3D58DE670398
Public Property Let DateObsolete(ByVal Value As Date)
    mDateObsolete = Value
End Property

'##ModelId=3D58DE6A00B4
Public Property Get DateObsolete() As Date
    DateObsolete = mDateObsolete
End Property

'##ModelId=3D58DE6B03DE
Public Property Let ItemDeleted(ByVal Value As Boolean)
    mItemDeleted = Value
End Property

'##ModelId=3D58DE6E00F0
Public Property Get ItemDeleted() As Boolean
    ItemDeleted = mItemDeleted
End Property

'##ModelId=3D58DE6F0262
Public Property Let DateDeleted(ByVal Value As Date)
    mDateDeleted = Value
End Property

'##ModelId=3D58DE710366
Public Property Get DateDeleted() As Date
    DateDeleted = mDateDeleted
End Property

'##ModelId=3D58DE7300F0
Public Property Let DateCreated(ByVal Value As Date)
    mDateCreated = Value
End Property

'##ModelId=3D58DE750334
Public Property Get DateCreated() As Date
    DateCreated = mDateCreated
End Property

'##ModelId=3D58DE7B0398
Public Property Let RelatedItemSingle(ByVal Value As Boolean)
    mRelatedItemSingle = Value
End Property

'##ModelId=3D58DE7E0262
Public Property Get RelatedItemSingle() As Boolean
    RelatedItemSingle = mRelatedItemSingle
End Property

'##ModelId=3D58DE800104
Public Property Let RelatedNoItems(ByVal Value As Long)
    mRelatedNoItems = Value
End Property

'##ModelId=3D58DE830000
Public Property Get RelatedNoItems() As Long
    RelatedNoItems = mRelatedNoItems
End Property

'##ModelId=3D58DE8803DE
Public Property Let CatchAll(ByVal Value As Boolean)
    mCatchAll = Value
End Property

'##ModelId=3D58DE8C00B4
Public Property Get CatchAll() As Boolean
    CatchAll = mCatchAll
End Property

'##ModelId=3D58DE8D0334
Public Property Let ItemTagged(ByVal Value As Boolean)
    mItemTagged = Value
End Property

'##ModelId=3D58DE9001FE
Public Property Get ItemTagged() As Boolean
    ItemTagged = mItemTagged
End Property

'##ModelId=3D58DE9D032A
Public Property Let ValueSoldYesterday(ByVal Value As Currency)
    mValueSoldYesterday = Value
End Property

'##ModelId=3D58DEA0014A
Public Property Get ValueSoldYesterday() As Currency
    ValueSoldYesterday = mValueSoldYesterday
End Property

'##ModelId=3D58DEA20028
Public Property Let UnitsSoldYesterday(ByVal Value As Long)
    mUnitsSoldYesterday = Value
End Property

'##ModelId=3D58DEA502D0
Public Property Get UnitsSoldYesterday() As Long
    UnitsSoldYesterday = mUnitsSoldYesterday
End Property

'##ModelId=3D58DE9D032A
Public Property Let ValueSoldThisWeek(ByVal Value As Currency)
    mValueSoldThisWeek = Value
End Property

'##ModelId=3D58DEA0014A
Public Property Get ValueSoldThisWeek() As Currency
    ValueSoldThisWeek = mValueSoldThisWeek
End Property

'##ModelId=3D58DEA20028
Public Property Let UnitsSoldThisWeek(ByVal Value As Long)
    mUnitsSoldThisWeek = Value
End Property

'##ModelId=3D58DEA502D0
Public Property Get UnitsSoldThisWeek() As Long
    UnitsSoldThisWeek = mUnitsSoldThisWeek
End Property

'##ModelId=3D58DE9D032A
Public Property Let ValueSoldLastWeek(ByVal Value As Currency)
    mValueSoldLastWeek = Value
End Property

'##ModelId=3D58DEA0014A
Public Property Get ValueSoldLastWeek() As Currency
    ValueSoldLastWeek = mValueSoldLastWeek
End Property

'##ModelId=3D58DEA20028
Public Property Let UnitsSoldLastWeek(ByVal Value As Long)
    mUnitsSoldLastWeek = Value
End Property

'##ModelId=3D58DEA502D0
Public Property Get UnitsSoldLastWeek() As Long
    UnitsSoldLastWeek = mUnitsSoldLastWeek
End Property

'##ModelId=3D58DE9D032A
Public Property Let ValueSoldThisPeriod(ByVal Value As Currency)
    mValueSoldThisPeriod = Value
End Property

'##ModelId=3D58DEA0014A
Public Property Get ValueSoldThisPeriod() As Currency
    ValueSoldThisPeriod = mValueSoldThisPeriod
End Property

'##ModelId=3D58DEA20028
Public Property Let UnitsSoldThisPeriod(ByVal Value As Long)
    mUnitsSoldThisPeriod = Value
End Property

'##ModelId=3D58DEA502D0
Public Property Get UnitsSoldThisPeriod() As Long
    UnitsSoldThisPeriod = mUnitsSoldThisPeriod
End Property

'##ModelId=3D58DE9D032A
Public Property Let ValueSoldLastPeriod(ByVal Value As Currency)
    mValueSoldLastPeriod = Value
End Property

'##ModelId=3D58DEA0014A
Public Property Get ValueSoldLastPeriod() As Currency
    ValueSoldLastPeriod = mValueSoldLastPeriod
End Property

'##ModelId=3D58DEA20028
Public Property Let UnitsSoldLastPeriod(ByVal Value As Long)
    mUnitsSoldLastPeriod = Value
End Property

'##ModelId=3D58DEA502D0
Public Property Get UnitsSoldLastPeriod() As Long
    UnitsSoldLastPeriod = mUnitsSoldLastPeriod
End Property

'##ModelId=3D58DE9D032A
Public Property Let ValueSoldThisYear(ByVal Value As Currency)
    mValueSoldThisYear = Value
End Property

'##ModelId=3D58DEA0014A
Public Property Get ValueSoldThisYear() As Currency
    ValueSoldThisYear = mValueSoldThisYear
End Property

'##ModelId=3D58DEA20028
Public Property Let UnitsSoldThisYear(ByVal Value As Long)
    mUnitsSoldThisYear = Value
End Property

'##ModelId=3D58DEA502D0
Public Property Get UnitsSoldThisYear() As Long
    UnitsSoldThisYear = mUnitsSoldThisYear
End Property

'##ModelId=3D58DE9D032A
Public Property Let ValueSoldLastYear(ByVal Value As Currency)
    mValueSoldLastYear = Value
End Property

'##ModelId=3D58DEA0014A
Public Property Get ValueSoldLastYear() As Currency
    ValueSoldLastYear = mValueSoldLastYear
End Property

'##ModelId=3D58DEA20028
Public Property Let UnitsSoldLastYear(ByVal Value As Long)
    mUnitsSoldLastYear = Value
End Property

'##ModelId=3D58DEA502D0
Public Property Get UnitsSoldLastYear() As Long
    UnitsSoldLastYear = mUnitsSoldLastYear
End Property

'##ModelId=3D58E1820172
Public Property Get CalcDay(Index As Variant) As Long
   Let CalcDay = mCalcDay(Index)
End Property

'##ModelId=3D58E17F0014
Public Property Let CalcDay(Index As Variant, ByVal Value As Long)
    Let mCalcDay(Index) = Value
End Property

'##ModelId=3D58E17C03D4
Public Property Get UnitsSoldWeek(Index As Variant) As Long
   Let UnitsSoldWeek = mUnitsSoldWeek(Index)
End Property

'##ModelId=3D58E1790276
Public Property Let UnitsSoldWeek(Index As Variant, ByVal Value As Long)
    Let mUnitsSoldWeek(Index) = Value
End Property

'##ModelId=3D58E1770226
Public Property Get ConfidentWeeklyAverage() As Boolean
   Let ConfidentWeeklyAverage = mConfidentWeeklyAverage
End Property

'##ModelId=3D58E17400FA
Public Property Let ConfidentWeeklyAverage(ByVal Value As Boolean)
    Let mConfidentWeeklyAverage = Value
End Property

'##ModelId=3D58E17200DC
Public Property Get WeeklyUpdate() As Boolean
   Let WeeklyUpdate = mWeeklyUpdate
End Property

'##ModelId=3D58E16E03D4
Public Property Let WeeklyUpdate(ByVal Value As Boolean)
    Let mWeeklyUpdate = Value
End Property

'##ModelId=3D58E16C03B6
Public Property Get NoWeeksUpdated() As Long
   Let NoWeeksUpdated = mNoWeeksUpdated
End Property

'##ModelId=3D58E16902C6
Public Property Let NoWeeksUpdated(ByVal Value As Long)
    Let mNoWeeksUpdated = Value
End Property

'##ModelId=3D58E167029E
Public Property Get DateFirstStock() As Date
   Let DateFirstStock = mDateFirstStock
End Property

'##ModelId=3D58E16401AE
Public Property Let DateFirstStock(ByVal Value As Date)
    Let mDateFirstStock = Value
End Property

'##ModelId=3D58E11203D4
Public Property Get AverageWeeklySales() As Currency
   Let AverageWeeklySales = mAverageWeeklySales
End Property

'##ModelId=3D58E11000B4
Public Property Let AverageWeeklySales(ByVal Value As Currency)
    Let mAverageWeeklySales = Value
End Property

'##ModelId=3D58E0FC02DA
Public Property Get DaysOutStockPeriod() As Long
   Let DaysOutStockPeriod = mDaysOutStockPeriod
End Property

'##ModelId=3D58E0FA0028
Public Property Let DaysOutStockPeriod(ByVal Value As Long)
    Let mDaysOutStockPeriod = Value
End Property

Public Property Let Weight(ByVal Value As Double)
    mWeight = Value
End Property

Public Property Get Weight() As Double
    Weight = mWeight
End Property

Public Property Get ShortDescription() As String
    ShortDescription = mShortDescription
End Property

Public Property Let ShortDescription(ByVal Value As String)
    mShortDescription = Value
End Property

Public Property Get NoOfPriceChangeRecs() As Long
    NoOfPriceChangeRecs = mNoOfPriceChangeRecs
End Property

Public Property Let NoOfPriceChangeRecs(ByVal Value As Long)
    mNoOfPriceChangeRecs = Value
End Property

Public Property Get NonStockItem() As Boolean
    NonStockItem = mNonStockItem
End Property

Public Property Let NonStockItem(ByVal Value As Boolean)
    mNonStockItem = Value
End Property

Public Property Get DaysOutOfStock() As Long
    DaysOutOfStock = mDaysOutOfStock
End Property

Public Property Let DaysOutOfStock(ByVal Value As Long)
    mDaysOutOfStock = Value
End Property

Public Property Get AvgWeeklySales() As Currency
    AvgWeeklySales = mAvgWeeklySales
End Property

Public Property Let AvgWeeklySales(ByVal Value As Currency)
    mAvgWeeklySales = Value
End Property

Public Property Get SOQv4Weeks() As Long
    SOQv4Weeks = mSOQv4Weeks
End Property

Public Property Let SOQv4Weeks(ByVal Value As Long)
    mSOQv4Weeks = Value
End Property

Public Property Get SOQv13Weeks() As Long
    SOQv13Weeks = mSOQv13Weeks
End Property

Public Property Let SOQv13Weeks(ByVal Value As Long)
    mSOQv13Weeks = Value
End Property

Public Property Get SOQvLastWeek() As Long
    SOQvLastWeek = mSOQvLastWeek
End Property

Public Property Let SOQvLastWeek(ByVal Value As Long)
    mSOQvLastWeek = Value
End Property

Public Property Get OrderPlacedThisSOQ() As Boolean
    OrderPlacedThisSOQ = mOrderPlacedThisSOQ
End Property

Public Property Let OrderPlacedThisSOQ(ByVal Value As Boolean)
    mOrderPlacedThisSOQ = Value
End Property

Public Property Get UnitsReceivedToday() As Long
    UnitsReceivedToday = mUnitsReceivedToday
End Property

Public Property Let UnitsReceivedToday(ByVal Value As Long)
    mUnitsReceivedToday = Value
End Property

Public Property Get ValueReceivedToday() As Currency
    ValueReceivedToday = mValueReceivedToday
End Property

Public Property Let ValueReceivedToday(ByVal Value As Currency)
    mValueReceivedToday = Value
End Property

Public Property Get ActivityToday() As Boolean
    ActivityToday = mActivityToday
End Property

Public Property Let ActivityToday(ByVal Value As Boolean)
    mActivityToday = Value
End Property

Public Property Get UnitsInOpenReturns() As Long
    UnitsInOpenReturns = mUnitsInOpenReturns
End Property

Public Property Let UnitsInOpenReturns(ByVal Value As Long)
    mUnitsInOpenReturns = Value
End Property

Public Property Get ValueInOpenReturns() As Currency
    ValueInOpenReturns = mValueInOpenReturns
End Property

Public Property Let ValueInOpenReturns(ByVal Value As Currency)
    mValueInOpenReturns = Value
End Property

Public Property Get HOCheckDigit() As String
    HOCheckDigit = mHOCheckDigit
End Property

Public Property Let HOCheckDigit(ByVal Value As String)
    mHOCheckDigit = Value
End Property

Public Property Get NoOfSmallLabels() As Long
    NoOfSmallLabels = mNoOfSmallLabels
End Property

Public Property Let NoOfSmallLabels(ByVal Value As Long)
    mNoOfSmallLabels = Value
End Property

Public Property Get UnitsStandingOrders() As String
    UnitsStandingOrders = mUnitsStandingOrders
End Property

Public Property Let UnitsStandingOrders(ByVal Value As String)
    mUnitsStandingOrders = Value
End Property

Public Property Get ValueStandingOrders() As Long
    ValueStandingOrders = mValueStandingOrders
End Property

Public Property Let ValueStandingOrders(ByVal Value As Long)
    mValueStandingOrders = Value
End Property

Public Property Get StandingOrderDay1() As String
    StandingOrderDay1 = mStandingOrderDay1
End Property

Public Property Let StandingOrderDay1(ByVal Value As String)
    mStandingOrderDay1 = Value
End Property

Public Property Get StandingOrderDay2() As String
    StandingOrderDay2 = mStandingOrderDay2
End Property

Public Property Let StandingOrderDay2(ByVal Value As String)
    mStandingOrderDay2 = Value
End Property

Public Property Get StandingOrderDay3() As String
    StandingOrderDay3 = mStandingOrderDay3
End Property

Public Property Let StandingOrderDay3(ByVal Value As String)
    mStandingOrderDay3 = Value
End Property

Public Property Get NoOfMediumLabels() As Long
    NoOfMediumLabels = mNoOfMediumLabels
End Property

Public Property Let NoOfMediumLabels(ByVal Value As Long)
    mNoOfMediumLabels = Value
End Property

Public Property Get NoOfLargeLabels() As Long
    NoOfLargeLabels = mNoOfLargeLabels
End Property

Public Property Let NoOfLargeLabels(ByVal Value As Long)
    mNoOfLargeLabels = Value
End Property

Public Property Get ItemVolume() As Double
    ItemVolume = mItemVolume
End Property

Public Property Let ItemVolume(ByVal Value As Double)
    mItemVolume = Value
End Property

Public Property Get DoNotOrder() As Boolean
    DoNotOrder = mDoNotOrder
End Property

Public Property Let DoNotOrder(ByVal Value As Boolean)
    mDoNotOrder = Value
End Property

Public Property Get AlternateSupplier() As String
    AlternateSupplier = mAlternateSupplier
End Property

Public Property Let AlternateSupplier(ByVal Value As String)
    mAlternateSupplier = Value
End Property

Public Property Get InitialOrderDate() As Date
    InitialOrderDate = mInitialOrderDate
End Property

Public Property Let InitialOrderDate(ByVal Value As Date)
    mInitialOrderDate = Value
End Property

Public Property Get FinalOrderDate() As Date
    FinalOrderDate = mFinalOrderDate
End Property

Public Property Let FinalOrderDate(ByVal Value As Date)
    mFinalOrderDate = Value
End Property

Public Property Get PromotionalMinimum() As Long
    PromotionalMinimum = mPromotionalMinimum
End Property

Public Property Let PromotionalMinimum(ByVal Value As Long)
    mPromotionalMinimum = Value
End Property

Public Property Get PromotionalMinimumStart() As Date
    PromotionalMinimumStart = mPromotionalMinimumStart
End Property

Public Property Let PromotionalMinimumStart(ByVal Value As Date)
    mPromotionalMinimumStart = Value
End Property

Public Property Get PromotionalMinimumEnd() As Date
    PromotionalMinimumEnd = mPromotionalMinimumEnd
End Property

Public Property Let PromotionalMinimumEnd(ByVal Value As Date)
    mPromotionalMinimumEnd = Value
End Property

Public Property Get PromotionalMinimumMCP() As String
    PromotionalMinimumMCP = mPromotionalMinimumMCP
End Property

Public Property Let PromotionalMinimumMCP(ByVal Value As String)
    mPromotionalMinimumMCP = Value
End Property

Public Property Get SpacemanDisplayFactor() As Long
    SpacemanDisplayFactor = mSpacemanDisplayFactor
End Property

Public Property Let SpacemanDisplayFactor(ByVal Value As Long)
    mSpacemanDisplayFactor = Value
End Property

Public Property Get DateMinimumLastChanged() As Date
    DateMinimumLastChanged = mDateMinimumLastChanged
End Property

Public Property Let DateMinimumLastChanged(ByVal Value As Date)
    mDateMinimumLastChanged = Value
End Property

Public Property Get ParticipatingInMCP() As Boolean
    ParticipatingInMCP = mParticipatingInMCP
End Property

Public Property Let ParticipatingInMCP(ByVal Value As Boolean)
    mParticipatingInMCP = Value
End Property

Public Property Get ItemTagType() As String
    ItemTagType = mItemTagType
End Property

Public Property Let ItemTagType(ByVal Value As String)
    mItemTagType = Value
End Property

Public Property Get ProductEquivalentDescription() As String
    ProductEquivalentDescription = mProductEquivalentDescription
End Property

Public Property Let ProductEquivalentDescription(ByVal Value As String)
    mProductEquivalentDescription = Value
End Property

Public Property Get HierCategoryGroup() As String
    HierCategoryGroup = mHierCategoryGroup
End Property

Public Property Let HierCategoryGroup(ByVal Value As String)
    mHierCategoryGroup = Value
End Property

Public Property Get RetailPriceEventNo() As String
    RetailPriceEventNo = mRetailPriceEventNo
End Property

Public Property Let RetailPriceEventNo(ByVal Value As String)
    mRetailPriceEventNo = Value
End Property

Public Property Get RetailPricePriority() As String
    RetailPricePriority = mRetailPricePriority
End Property

Public Property Let RetailPricePriority(ByVal Value As String)
    mRetailPricePriority = Value
End Property

Public Property Get EquivalentPriceMult() As Double
    EquivalentPriceMult = mEquivalentPriceMult
End Property

Public Property Let EquivalentPriceMult(ByVal Value As Double)
    mEquivalentPriceMult = Value
End Property

Public Property Get EquivalentPriceUnit() As String
    EquivalentPriceUnit = mEquivalentPriceUnit
End Property

Public Property Let EquivalentPriceUnit(ByVal Value As String)
    mEquivalentPriceUnit = Value
End Property

Public Property Get MarkDownQuantity() As Long
    MarkDownQuantity = mMarkDownQuantity
End Property

Public Property Let MarkDownQuantity(ByVal Value As Long)
    mMarkDownQuantity = Value
End Property

Public Property Get WriteOffQuantity() As Long
    WriteOffQuantity = mWriteOffQuantity
End Property

Public Property Let WriteOffQuantity(ByVal Value As Long)
    mWriteOffQuantity = Value
End Property

Public Property Get AutoApplyPriceChanges() As Boolean
    AutoApplyPriceChanges = mAutoApplyPriceChanges
End Property

Public Property Let AutoApplyPriceChanges(ByVal Value As Boolean)
    mAutoApplyPriceChanges = Value
End Property

Public Property Get AllowAdjustments() As String
    AllowAdjustments = mAllowAdjustments
End Property

Public Property Let AllowAdjustments(ByVal Value As String)
    mAllowAdjustments = Value
End Property

Public Property Get SavedSupplier() As String
    SavedSupplier = mSavedSupplier
End Property

Public Property Let SavedSupplier(ByVal Value As String)
    mSavedSupplier = Value
End Property

Public Property Let BallastItem(ByVal Value As Boolean)
    mBallastItem = Value
End Property

Public Property Get BallastItem() As Boolean
    BallastItem = mBallastItem
End Property

'<CACH>****************************************************************************************
'* Function:  Boolean LoadFromRow()
'**********************************************************************************************
'* Description: Part of the IBo interface called by the DB object to pass in a row of field and
'*              for this object to extract the data and populate the properties of the object.
'**********************************************************************************************
'* Parameters:
'*In/Out:oRow   Object. - collection of fields
'**********************************************************************************************
'* Returns:  Boolean
'**********************************************************************************************
'* History:
'* 13/08/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Function LoadFromRow(oRow As IRow) As Boolean

Dim lFieldNo As Integer
Dim oField   As IField

Const PROCEDURE_NAME As String = MODULE_NAME & ".LoadFromRow"

    LoadFromRow = True
    For lFieldNo = 1 To oRow.Count Step 1
        Set oField = oRow.Field(lFieldNo)
        Select Case (oField.Id)
            Case (FID_INVENTORY_PartCode):              mPartCode = oField.ValueAsVariant
            Case (FID_INVENTORY_Description):           mDescription = oField.ValueAsVariant
            Case (FID_INVENTORY_VATRate):               mVATRate = oField.ValueAsVariant
            Case (FID_INVENTORY_SupplierUnitCode):      mSupplierUnitCode = oField.ValueAsVariant
            Case (FID_INVENTORY_SupplierNo):            mSupplierNo = oField.ValueAsVariant
            Case (FID_INVENTORY_SupplierPartCode):      mSupplierPartCode = oField.ValueAsVariant
            Case (FID_INVENTORY_SupplierPackSize):      mSupplierPackSize = oField.ValueAsVariant
            Case (FID_INVENTORY_NormalSellPrice):       mNormalSellPrice = oField.ValueAsVariant
            Case (FID_INVENTORY_PriorSellPrice):        mPriorSellPrice = oField.ValueAsVariant
            Case (FID_INVENTORY_CostPrice):             mCostPrice = oField.ValueAsVariant
            Case (FID_INVENTORY_LastSold):              mLastSold = oField.ValueAsVariant
            Case (FID_INVENTORY_LastReceived):          mLastReceived = oField.ValueAsVariant
            Case (FID_INVENTORY_LastOrdered):           mLastOrdered = oField.ValueAsVariant
            Case (FID_INVENTORY_PriceEffectiveDate):    mPriceEffectiveDate = oField.ValueAsVariant
            Case (FID_INVENTORY_DateCreated):           mDateCreated = oField.ValueAsVariant
            Case (FID_INVENTORY_DateObsolete):          mDateObsolete = oField.ValueAsVariant
            Case (FID_INVENTORY_DateDeleted):           mDateDeleted = oField.ValueAsVariant
            Case (FID_INVENTORY_QuantityAtHand):        mQuantityAtHand = oField.ValueAsVariant
            Case (FID_INVENTORY_QuantityOnOrder):       mQuantityOnOrder = oField.ValueAsVariant
            Case (FID_INVENTORY_MinQuantity):           mMinQuantity = oField.ValueAsVariant
            Case (FID_INVENTORY_MaxQuantity):           mMaxQuantity = oField.ValueAsVariant
            Case (FID_INVENTORY_Status):                mStatus = oField.ValueAsVariant
            Case (FID_INVENTORY_RelatedItemSingle):     mRelatedItemSingle = oField.ValueAsVariant
            Case (FID_INVENTORY_RelatedNoItems):        mRelatedNoItems = oField.ValueAsVariant
            Case (FID_INVENTORY_CatchAll):              mCatchAll = oField.ValueAsVariant
            Case (FID_INVENTORY_ItemObsolete):          mItemObsolete = oField.ValueAsVariant
            Case (FID_INVENTORY_ItemDeleted):           mItemDeleted = oField.ValueAsVariant
            Case (FID_INVENTORY_ItemTagged):            mItemTagged = oField.ValueAsVariant
            Case (FID_INVENTORY_Warranty):              mWarranty = oField.ValueAsVariant
            Case (FID_INVENTORY_EAN):                   mEAN = oField.ValueAsVariant
            Case (FID_INVENTORY_ValueSoldYesterday):    mValueSoldYesterday = oField.ValueAsVariant
            Case (FID_INVENTORY_UnitsSoldYesterday):    mUnitsSoldYesterday = oField.ValueAsVariant
            Case (FID_INVENTORY_ValueSoldThisWeek):     mValueSoldThisWeek = oField.ValueAsVariant
            Case (FID_INVENTORY_UnitsSoldThisWeek):     mUnitsSoldThisWeek = oField.ValueAsVariant
            Case (FID_INVENTORY_ValueSoldLastWeek):     mValueSoldLastWeek = oField.ValueAsVariant
            Case (FID_INVENTORY_UnitsSoldLastWeek):     mUnitsSoldLastWeek = oField.ValueAsVariant
            Case (FID_INVENTORY_ValueSoldThisPeriod):   mValueSoldThisPeriod = oField.ValueAsVariant
            Case (FID_INVENTORY_UnitsSoldThisPeriod):   mUnitsSoldThisPeriod = oField.ValueAsVariant
            Case (FID_INVENTORY_ValueSoldLastPeriod):   mValueSoldLastPeriod = oField.ValueAsVariant
            Case (FID_INVENTORY_UnitsSoldLastPeriod):   mUnitsSoldLastPeriod = oField.ValueAsVariant
            Case (FID_INVENTORY_ValueSoldThisYear):     mValueSoldThisYear = oField.ValueAsVariant
            Case (FID_INVENTORY_UnitsSoldThisYear):     mUnitsSoldThisYear = oField.ValueAsVariant
            Case (FID_INVENTORY_ValueSoldLastYear):     mValueSoldLastYear = oField.ValueAsVariant
            Case (FID_INVENTORY_UnitsSoldLastYear):     mUnitsSoldLastYear = oField.ValueAsVariant
            Case (FID_INVENTORY_DaysOutStockPeriod):    mDaysOutStockPeriod = oField.ValueAsVariant
            Case (FID_INVENTORY_AverageWeeklySales):    mAverageWeeklySales = oField.ValueAsVariant
            Case (FID_INVENTORY_DateFirstStock):        mDateFirstStock = oField.ValueAsVariant
            Case (FID_INVENTORY_NoWeeksUpdated):        mNoWeeksUpdated = oField.ValueAsVariant
            Case (FID_INVENTORY_WeeklyUpdate):          mWeeklyUpdate = oField.ValueAsVariant
            Case (FID_INVENTORY_ConfidentWeeklyAverage):   mConfidentWeeklyAverage = oField.ValueAsVariant
            Case (FID_INVENTORY_UnitsSoldWeek):         Call LoadLongArray(mUnitsSoldWeek, oField, m_oSession)
            Case (FID_INVENTORY_CalcDay):               Call LoadLongArray(mCalcDay, oField, m_oSession)
            Case (FID_INVENTORY_Weight):                mWeight = oField.ValueAsVariant
            Case (FID_INVENTORY_ShortDescription):             mShortDescription = oField.ValueAsVariant
            Case (FID_INVENTORY_NoOfPriceChangeRecs):          mNoOfPriceChangeRecs = oField.ValueAsVariant
            Case (FID_INVENTORY_NonStockItem):                 mNonStockItem = oField.ValueAsVariant
            Case (FID_INVENTORY_DaysOutOfStock):               mDaysOutOfStock = oField.ValueAsVariant
            Case (FID_INVENTORY_AvgWeeklySales):               mAvgWeeklySales = oField.ValueAsVariant
            Case (FID_INVENTORY_SOQv4Weeks):                   mSOQv4Weeks = oField.ValueAsVariant
            Case (FID_INVENTORY_SOQv13Weeks):                  mSOQv13Weeks = oField.ValueAsVariant
            Case (FID_INVENTORY_SOQvLastWeek):                 mSOQvLastWeek = oField.ValueAsVariant
            Case (FID_INVENTORY_OrderPlacedThisSOQ):           mOrderPlacedThisSOQ = oField.ValueAsVariant
            Case (FID_INVENTORY_UnitsReceivedToday):           mUnitsReceivedToday = oField.ValueAsVariant
            Case (FID_INVENTORY_ValueReceivedToday):           mValueReceivedToday = oField.ValueAsVariant
            Case (FID_INVENTORY_ActivityToday):                mActivityToday = oField.ValueAsVariant
            Case (FID_INVENTORY_UnitsInOpenReturns):           mUnitsInOpenReturns = oField.ValueAsVariant
            Case (FID_INVENTORY_ValueInOpenReturns):           mValueInOpenReturns = oField.ValueAsVariant
            Case (FID_INVENTORY_HOCheckDigit):                 mHOCheckDigit = oField.ValueAsVariant
            Case (FID_INVENTORY_NoOfSmallLabels):              mNoOfSmallLabels = oField.ValueAsVariant
            Case (FID_INVENTORY_UnitsStandingOrders):          mUnitsStandingOrders = oField.ValueAsVariant
            Case (FID_INVENTORY_ValueStandingOrders):          mValueStandingOrders = oField.ValueAsVariant
            Case (FID_INVENTORY_StandingOrderDay1):            mStandingOrderDay1 = oField.ValueAsVariant
            Case (FID_INVENTORY_StandingOrderDay2):            mStandingOrderDay2 = oField.ValueAsVariant
            Case (FID_INVENTORY_StandingOrderDay3):            mStandingOrderDay3 = oField.ValueAsVariant
            Case (FID_INVENTORY_NoOfMediumLabels):             mNoOfMediumLabels = oField.ValueAsVariant
            Case (FID_INVENTORY_NoOfLargeLabels):              mNoOfLargeLabels = oField.ValueAsVariant
            Case (FID_INVENTORY_ItemVolume):                   mItemVolume = oField.ValueAsVariant
            Case (FID_INVENTORY_DoNotOrder):                   mDoNotOrder = oField.ValueAsVariant
            Case (FID_INVENTORY_AlternateSupplier):            mAlternateSupplier = oField.ValueAsVariant
            Case (FID_INVENTORY_InitialOrderDate):             mInitialOrderDate = oField.ValueAsVariant
            Case (FID_INVENTORY_FinalOrderDate):               mFinalOrderDate = oField.ValueAsVariant
            Case (FID_INVENTORY_PromotionalMinimum):           mPromotionalMinimum = oField.ValueAsVariant
            Case (FID_INVENTORY_PromotionalMinimumStart):      mPromotionalMinimumStart = oField.ValueAsVariant
            Case (FID_INVENTORY_PromotionalMinimumEnd):        mPromotionalMinimumEnd = oField.ValueAsVariant
            Case (FID_INVENTORY_PromotionalMinimumMCP):        mPromotionalMinimumMCP = oField.ValueAsVariant
            Case (FID_INVENTORY_SpacemanDisplayFactor):        mSpacemanDisplayFactor = oField.ValueAsVariant
            Case (FID_INVENTORY_DateMinimumLastChanged):       mDateMinimumLastChanged = oField.ValueAsVariant
            Case (FID_INVENTORY_ParticipatingInMCP):           mParticipatingInMCP = oField.ValueAsVariant
            Case (FID_INVENTORY_ItemTagType):                  mItemTagType = oField.ValueAsVariant
            Case (FID_INVENTORY_ProductEquivalentDescription): mProductEquivalentDescription = oField.ValueAsVariant
            Case (FID_INVENTORY_HierCategoryGroup):            mHierCategoryGroup = oField.ValueAsVariant
            Case (FID_INVENTORY_RetailPriceEventNo):           mRetailPriceEventNo = oField.ValueAsVariant
            Case (FID_INVENTORY_RetailPricePriority):          mRetailPricePriority = oField.ValueAsVariant
            Case (FID_INVENTORY_EquivalentPriceMult):          mEquivalentPriceMult = oField.ValueAsVariant
            Case (FID_INVENTORY_EquivalentPriceUnit):          mEquivalentPriceUnit = oField.ValueAsVariant
            Case (FID_INVENTORY_MarkDownQuantity):             mMarkDownQuantity = oField.ValueAsVariant
            Case (FID_INVENTORY_WriteOffQuantity):             mWriteOffQuantity = oField.ValueAsVariant
            Case (FID_INVENTORY_AutoApplyPriceChanges):        mAutoApplyPriceChanges = oField.ValueAsVariant
            Case (FID_INVENTORY_AllowAdjustments):             mAllowAdjustments = oField.ValueAsVariant
            Case (FID_INVENTORY_SavedSupplier):                mSavedSupplier = oField.ValueAsVariant
            Case (FID_INVENTORY_WebOrderQuantity):             mWebOrderQuantity = oField.ValueAsVariant
            Case (FID_INVENTORY_BallastItem):                  mBallastItem = (oField.ValueAsVariant = "Y")
            Case (FID_INVENTORY_WEEERate):                     mWEEERate = oField.ValueAsVariant
            Case (FID_INVENTORY_WEEESequence):                 mWEEESequence = oField.ValueAsVariant
            Case (FID_INVENTORY_PRFSKU):                       mPRFSKU = oField.ValueAsVariant
            Case Else: 'invalid field ID passed in
                LoadFromRow = False
        End Select
    Next lFieldNo

End Function 'LoadFromRow


Private Sub Class_Initialize()
    
    Call DebugMsg(MODULE_NAME, "Initialise", endlTraceIn)
    
End Sub

Private Function IBo_CreateNew() As IBo
    
    Set IBo_CreateNew = New cInventory

End Function

Private Property Get IBo_DebugString() As String
    
    IBo_DebugString = "Inventory Item " & mPartCode

End Property

Public Function IBo_GetField(nFid As Long) As IField
    
    Set IBo_GetField = GetField(nFid)

End Function

Private Function IBo_GetSelectAllRow() As IRowSelector
    
    Set IBo_GetSelectAllRow = GetSelectAllRow

End Function

Private Function Initialise(oSession As ISession) As cInventory
    Set m_oSession = oSession
    Set Initialise = Me
End Function

Private Function IBo_Initialise(oSession As ISession) As IBo
    
    Set IBo_Initialise = Initialise(oSession)

End Function

Public Property Get IBo_ClassId() As Integer

    IBo_ClassId = CLASSID_INVENTORY

End Property

Public Property Get IBo_ClassName() As String

    IBo_ClassName = MODULE_NAME

End Property

Public Function IBo_Load() As Boolean

    IBo_Load = Load

End Function

Private Function ISysBo_LoadFromRow(oRow As IRow) As Boolean
    
    Call LoadFromRow(oRow)

End Function

Private Property Get IBo_Version() As String
    
    IBo_Version = App.Major & "." & App.Minor & "." & App.Revision

End Property

Public Function GetField(lFieldID As Long) As IField

    If CheckIsUnInitialised(m_oSession, IBo_ClassName) Then
        lFieldID = 0
        Exit Function
    End If
    On Error GoTo Error_Handler
    
    Select Case (lFieldID)
        Case (FID_INVENTORY_PartCode):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mPartCode
        Case (FID_INVENTORY_Description):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mDescription
        Case (FID_INVENTORY_VATRate):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mVATRate
        Case (FID_INVENTORY_SupplierUnitCode):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mSupplierUnitCode
        Case (FID_INVENTORY_SupplierNo):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mSupplierNo
        Case (FID_INVENTORY_SupplierPartCode):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mSupplierPartCode
        Case (FID_INVENTORY_SupplierPackSize):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mSupplierPackSize
        Case (FID_INVENTORY_NormalSellPrice):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mNormalSellPrice
        Case (FID_INVENTORY_PriorSellPrice):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mPriorSellPrice
        Case (FID_INVENTORY_CostPrice):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mCostPrice
        Case (FID_INVENTORY_LastSold):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mLastSold
        Case (FID_INVENTORY_LastReceived):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mLastReceived
        Case (FID_INVENTORY_LastOrdered):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mLastOrdered
        Case (FID_INVENTORY_PriceEffectiveDate):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mPriceEffectiveDate
        Case (FID_INVENTORY_DateCreated):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mDateCreated
        Case (FID_INVENTORY_DateObsolete):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mDateObsolete
        Case (FID_INVENTORY_DateDeleted):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mDateDeleted
        Case (FID_INVENTORY_QuantityAtHand):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mQuantityAtHand
        Case (FID_INVENTORY_QuantityOnOrder):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mQuantityOnOrder
        Case (FID_INVENTORY_MinQuantity):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mMinQuantity
        Case (FID_INVENTORY_MaxQuantity):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mMaxQuantity
        Case (FID_INVENTORY_Status):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mStatus
        Case (FID_INVENTORY_RelatedItemSingle):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mRelatedItemSingle
        Case (FID_INVENTORY_RelatedNoItems):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mRelatedNoItems
        Case (FID_INVENTORY_CatchAll):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mCatchAll
        Case (FID_INVENTORY_ItemObsolete):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mItemObsolete
        Case (FID_INVENTORY_ItemDeleted):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mItemDeleted
        Case (FID_INVENTORY_ItemTagged):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mItemTagged
        Case (FID_INVENTORY_Warranty):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mWarranty
        Case (FID_INVENTORY_EAN):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mEAN
        Case (FID_INVENTORY_ValueSoldYesterday):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mValueSoldYesterday
        Case (FID_INVENTORY_UnitsSoldYesterday):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mUnitsSoldYesterday
        Case (FID_INVENTORY_ValueSoldThisWeek):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mValueSoldThisWeek
        Case (FID_INVENTORY_UnitsSoldThisWeek):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mUnitsSoldThisWeek
        Case (FID_INVENTORY_ValueSoldLastWeek):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mValueSoldLastWeek
        Case (FID_INVENTORY_UnitsSoldLastWeek):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mUnitsSoldLastWeek
        Case (FID_INVENTORY_ValueSoldThisPeriod):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mValueSoldThisPeriod
        Case (FID_INVENTORY_UnitsSoldThisPeriod):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mUnitsSoldThisPeriod
        Case (FID_INVENTORY_ValueSoldLastPeriod):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mValueSoldLastPeriod
        Case (FID_INVENTORY_UnitsSoldLastPeriod):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mUnitsSoldLastPeriod
        Case (FID_INVENTORY_ValueSoldThisYear):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mValueSoldThisYear
        Case (FID_INVENTORY_UnitsSoldThisYear):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mUnitsSoldThisYear
        Case (FID_INVENTORY_ValueSoldLastYear):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mValueSoldLastYear
        Case (FID_INVENTORY_UnitsSoldLastYear):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mUnitsSoldLastYear
        Case (FID_INVENTORY_DaysOutStockPeriod):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mDaysOutStockPeriod
        Case (FID_INVENTORY_AverageWeeklySales):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mAverageWeeklySales
        Case (FID_INVENTORY_DateFirstStock):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mDateFirstStock
        Case (FID_INVENTORY_NoWeeksUpdated):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mNoWeeksUpdated
        Case (FID_INVENTORY_WeeklyUpdate):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mWeeklyUpdate
        Case (FID_INVENTORY_ConfidentWeeklyAverage):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mConfidentWeeklyAverage
        Case (FID_INVENTORY_UnitsSoldWeek): Set GetField = SaveLongArray(mUnitsSoldWeek, m_oSession)
        Case (FID_INVENTORY_CalcDay): Set GetField = SaveLongArray(mCalcDay, m_oSession)
        Case (FID_INVENTORY_Weight):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mWeight
        Case (FID_INVENTORY_ShortDescription):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mShortDescription
        Case (FID_INVENTORY_NoOfPriceChangeRecs):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mNoOfPriceChangeRecs
        Case (FID_INVENTORY_NonStockItem):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mNonStockItem
        Case (FID_INVENTORY_DaysOutOfStock):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mDaysOutOfStock
        Case (FID_INVENTORY_AvgWeeklySales):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mAvgWeeklySales
        Case (FID_INVENTORY_SOQv4Weeks):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mSOQv4Weeks
        Case (FID_INVENTORY_SOQv13Weeks):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mSOQv13Weeks
        Case (FID_INVENTORY_SOQvLastWeek):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mSOQvLastWeek
        Case (FID_INVENTORY_OrderPlacedThisSOQ):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mOrderPlacedThisSOQ
        Case (FID_INVENTORY_UnitsReceivedToday):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mUnitsReceivedToday
        Case (FID_INVENTORY_ValueReceivedToday):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mValueReceivedToday
        Case (FID_INVENTORY_ActivityToday):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mActivityToday
        Case (FID_INVENTORY_UnitsInOpenReturns):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mUnitsInOpenReturns
        Case (FID_INVENTORY_ValueInOpenReturns):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mValueInOpenReturns
        Case (FID_INVENTORY_HOCheckDigit):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mHOCheckDigit
        Case (FID_INVENTORY_NoOfSmallLabels):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mNoOfSmallLabels
        Case (FID_INVENTORY_UnitsStandingOrders):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mUnitsStandingOrders
        Case (FID_INVENTORY_ValueStandingOrders):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mValueStandingOrders
        Case (FID_INVENTORY_StandingOrderDay1):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mStandingOrderDay1
        Case (FID_INVENTORY_StandingOrderDay2):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mStandingOrderDay2
        Case (FID_INVENTORY_StandingOrderDay3):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mStandingOrderDay3
        Case (FID_INVENTORY_NoOfMediumLabels):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mNoOfMediumLabels
        Case (FID_INVENTORY_NoOfLargeLabels):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mNoOfLargeLabels
        Case (FID_INVENTORY_ItemVolume):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mItemVolume
        Case (FID_INVENTORY_DoNotOrder):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mDoNotOrder
        Case (FID_INVENTORY_AlternateSupplier):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mAlternateSupplier
        Case (FID_INVENTORY_InitialOrderDate):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mInitialOrderDate
        Case (FID_INVENTORY_FinalOrderDate):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mFinalOrderDate
        Case (FID_INVENTORY_PromotionalMinimum):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mPromotionalMinimum
        Case (FID_INVENTORY_PromotionalMinimumStart):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mPromotionalMinimumStart
        Case (FID_INVENTORY_PromotionalMinimumEnd):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mPromotionalMinimumEnd
        Case (FID_INVENTORY_PromotionalMinimumMCP):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mPromotionalMinimumMCP
        Case (FID_INVENTORY_SpacemanDisplayFactor):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mSpacemanDisplayFactor
        Case (FID_INVENTORY_DateMinimumLastChanged):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mDateMinimumLastChanged
        Case (FID_INVENTORY_ParticipatingInMCP):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mParticipatingInMCP
        Case (FID_INVENTORY_ItemTagType):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mItemTagType
        Case (FID_INVENTORY_ProductEquivalentDescription):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mProductEquivalentDescription
        Case (FID_INVENTORY_HierCategoryGroup):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mHierCategoryGroup
        Case (FID_INVENTORY_RetailPriceEventNo):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mRetailPriceEventNo
        Case (FID_INVENTORY_RetailPricePriority):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mRetailPricePriority
        Case (FID_INVENTORY_EquivalentPriceMult):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mEquivalentPriceMult
        Case (FID_INVENTORY_EquivalentPriceUnit):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mEquivalentPriceUnit
        Case (FID_INVENTORY_MarkDownQuantity):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mMarkDownQuantity
        Case (FID_INVENTORY_WriteOffQuantity):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mWriteOffQuantity
        Case (FID_INVENTORY_AutoApplyPriceChanges):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mAutoApplyPriceChanges
        Case (FID_INVENTORY_AllowAdjustments):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mAllowAdjustments
        Case (FID_INVENTORY_SavedSupplier):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mSavedSupplier
        Case (FID_INVENTORY_WebOrderQuantity):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mWebOrderQuantity
        Case (FID_INVENTORY_BallastItem):
                Set GetField = New CFieldString
                If (mBallastItem = True) Then
                    GetField.ValueAsVariant = "Y"
                Else
                    GetField.ValueAsVariant = "N"
                End If
        Case (FID_INVENTORY_WEEERate):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mWEEERate
        Case (FID_INVENTORY_WEEESequence):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mWEEESequence
        Case (FID_INVENTORY_PRFSKU):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mPRFSKU
        Case Else
                Call Err.Raise(OASYS_ERR_GETFIELD_INVALID_FID, MODULE_NAME, OASYS_ERR_GETFIELD_INVALID_FID_MSG & lFieldID)
    End Select
    
    If Not GetField Is Nothing Then GetField.Id = lFieldID
    
    Exit Function
    
Error_Handler:

    Call MsgBox(MODULE_NAME & " " & "GetField-" & lFieldID & vbCrLf & "Err:" & Err.Number & "-" & Err.Description)
    Resume Next

End Function

Private Function GetSelectAllRow() As IRowSelector
' Returns a CRow object containing one SelectAll field selector for each property.
    
    Set GetSelectAllRow = GetSelectAllRows(CLASSID_INVENTORY, FID_INVENTORY_END_OF_STATIC, m_oSession)

End Function

Private Function Load() As Boolean
    
' Load up all properties from the database
Dim oView       As IView
Dim oRSelector  As IRowSelector
    
    Load = False
    Call CheckIsUnInitialised(m_oSession, IBo_ClassName)
    
    If moRowSel Is Nothing Then
        Set oRSelector = m_oSession.Root.CreateUtilityObject("CRowSelector")
        Debug.Assert (LenB(mPartCode) <> 0)
        oRSelector.AddSelection CMP_EQUAL, GetField(FID_INVENTORY_PartCode)
        oRSelector.Merge GetSelectAllRow
        ' Pass the selector to the database to get the data view
        Set oView = m_oSession.Database.GetView(oRSelector)
    Else
        Call DebugMsg(MODULE_NAME, "Load", endlDebug, "GETALL")
        Set oRSelector = GetSelectAllRow
        Call DebugMsg(MODULE_NAME, "Load", endlDebug, "MERGE")
        Call moRowSel.Merge(oRSelector)
        Call DebugMsg(MODULE_NAME, "Load", endlDebug, "Get Data")
        ' Pass the selector to the database to get the data view
        Set oView = m_oSession.Database.GetView(moRowSel)
    End If
    
    Call DebugMsg(MODULE_NAME, "Load", endlDebug, "LoadFromRow")
    If Not (oView Is Nothing) Then
        If oView.Count > 0 Then Load = LoadFromRow(oView.Row(1))
    End If
    Call DebugMsg(MODULE_NAME, "Load", endlDebug, "Done")

End Function

Public Function IBo_Save() As Boolean

    IBo_Save = Save(SaveTypeAllCases)

End Function

Public Function IBo_SaveIfNew() As Boolean

    IBo_SaveIfNew = Save(SaveTypeIfNew)

End Function

Public Function IBo_SaveIfExists() As Boolean

    IBo_SaveIfExists = Save(SaveTypeIfExists)

End Function

Public Function IBo_Delete() As Boolean

    IBo_Delete = Save(SaveTypeDelete)

End Function

Public Function IBo_IsValid() As Boolean

    IBo_IsValid = IsValid()

End Function


'##ModelId=3D3D19F30316
Private Function Save(eSave As enSaveType) As Boolean

Dim oStockMove As cStockMovement
Dim oItemText  As cInventoryText
Dim colText    As Collection
Dim lngTextPos As Long
Dim strSection As String

' Save all properties to the database
    
    Save = False
    
    If IsValid() Then
        ' Get a row and pass it to the database to insert/update/delete
        Select Case (eSave)
            Case (SaveTypeIfNew):
                    Set oStockMove = m_oSession.Database.CreateBusinessObject(CLASSID_STOCKMOVE)
                    oStockMove.PartCode = mPartCode
                    Save = oStockMove.IBo_SaveIfNew
                    If Save = True Then Save = m_oSession.Database.SaveBo(eSave, Me)
                    Set oStockMove = Nothing
            Case Else:  Save = m_oSession.Database.SaveBo(eSave, Me)
        End Select
        
        'After saving Item, check if anything required for Text Body
    End If

End Function

Private Function Delete() As Boolean
    Debug.Assert False
End Function

Private Function IsValid() As Boolean
'    Debug.Assert False
    IsValid = True
End Function

Public Function Interface(Optional eInterfaceType As Long) As cInventory
    Select Case (eInterfaceType)
    Case BO_INTERFACE_IBO:
        Dim oBO As IBo
        Set oBO = Me
        Set Interface = oBO
    Case Else:
        Set Interface = Me
    End Select
End Function

Public Function IsBulkUpdateValid(oTarget As Object, oSource As Object, oRowSelector As IRowSelector) As Boolean
' This method is called by the oBoDatabase object to ask permission to do the update.
' We must determine if it is a valid operation and return True to tell the Db to go ahead
' or return False to cause the Db to fail to do the operation.
' If the FID for target and source are the same, then the source provides the value,
' otherwise the source provides the FID.
    Dim oTargetField    As Object
    Dim oSourceField    As Object
    
    On Error Resume Next
    Set oTargetField = oTarget.Interface(FIELD_INTERFACE_IFIELD)
    Set oSourceField = oSource.Interface(FIELD_INTERFACE_IFIELD)
    On Error GoTo 0
    
    If Not (oTargetField Is Nothing) Then
        ' We have been passed IFields
        IsBulkUpdateValid = True
    Else
        ' We have been passed CRows
        IsBulkUpdateValid = True
    End If
    
End Function

'<CACH>****************************************************************************************
'* Sub:  RecordItemOrdered()
'**********************************************************************************************
'* Description: Business rule called by PurchaseOrderLine.  Used to updates information on
'*              Stock Master showing Quantity on Order with date last ordered
'**********************************************************************************************
'* Parameters:
'*In/Out:sPartCode  String. - Unique Part Code used to load in Item if not already loaded
'*In/Out:dteOrderDate   Date. - date used to update Date last ordered field
'*In/Out:dblOrderQuantity   Double. - actaul quantity purchased- added to quantity on order
'**********************************************************************************************
'* History:
'* 08/11/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Sub RecordItemOrdered(sPartCode As String, dteOrderDate As Date, dblOrderQuantity As Double)

Dim oRow As IRow

Const PROCEDURE_NAME As String = MODULE_NAME & ".RecordItemOrdered"
            
    If mPartCode <> sPartCode Then
        Call AddLoadFilter(CMP_EQUAL, FID_INVENTORY_PartCode, sPartCode)
        
        Call AddLoadField(FID_INVENTORY_PartCode)
        Call AddLoadField(FID_INVENTORY_QuantityOnOrder)
        Call AddLoadField(FID_INVENTORY_LastOrdered)
        
        Call LoadMatches
        mQuantityOnOrder = mQuantityOnOrder + dblOrderQuantity
        mLastOrdered = dteOrderDate
    
        'Save updated fields back to Database
        Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
        Call oRow.Add(GetField(FID_INVENTORY_PartCode))
        Call oRow.Add(GetField(FID_INVENTORY_QuantityOnOrder))
        Call oRow.Add(GetField(FID_INVENTORY_LastOrdered))
    
        Call m_oSession.Database.SavePartialBo(Me, oRow)
        Set oRow = Nothing
    End If

End Sub 'RecordItemOrdered

'<CACH>****************************************************************************************
'* Sub:  RecordItemOrderCancel()
'**********************************************************************************************
'* Description: Business rule called by PurchaseOrderLine.  Used to updates information on
'*              Stock Master showing Quantity on Order with date last ordered
'**********************************************************************************************
'* Parameters:
'*In/Out:sPartCode  String. - Unique Part Code used to load in Item if not already loaded
'*In/Out:dblOSQuantity   Double. - actual quantity still oustanding on order
'**********************************************************************************************
'* History:
'* 08/11/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Sub RecordItemOrderCancel(sPartCode As String, dblOSQuantity As Double)

Dim oRow As IRow

Const PROCEDURE_NAME As String = MODULE_NAME & ".RecordItemOrderCancelled"
            
    If mPartCode <> sPartCode Then
        Call AddLoadFilter(CMP_EQUAL, FID_INVENTORY_PartCode, sPartCode)
        
        Call AddLoadField(FID_INVENTORY_PartCode)
        Call AddLoadField(FID_INVENTORY_QuantityOnOrder)
        
        Call LoadMatches
        mQuantityOnOrder = mQuantityOnOrder - dblOSQuantity
    
        'Save updated fields back to Database
        Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
        Call oRow.Add(GetField(FID_INVENTORY_PartCode))
        Call oRow.Add(GetField(FID_INVENTORY_QuantityOnOrder))
    
        Call m_oSession.Database.SavePartialBo(Me, oRow)
        Set oRow = Nothing
    End If

End Sub 'RecordItemOrderCancel

'<CACH>****************************************************************************************
'* Sub:  RecordItemReceived()
'**********************************************************************************************
'* Description: Business rule called by Delivery Note Line.  Used to updates information on
'*              Stock Master showing Quantity on Stock On Hand with date received and reducing
'*              Stock on order
'**********************************************************************************************
'* Parameters:
'*In/Out:sPartCode  String. - Unique Part Code used to load in Item if not already loaded
'*In/Out:dteDelNoteDate   Date. - date used to update Date last received field
'*In/Out:dblReceivedQuantity   Double. - actaul quantity received- added to quantity on hand
'*In/Out:blnOrdered Boolean - flag whether Item was ordered, if so update QTY on order
'**********************************************************************************************
'* History:
'* 08/11/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Sub RecordItemReceived(sPartCode As String, dteDelNoteDate As Date, dblReceivedQuantity As Double, blnOrdered As Boolean)

Dim oRow As IRow
            
    Call IBo_ClearLoadFilter
    
    Call AddLoadFilter(CMP_EQUAL, FID_INVENTORY_PartCode, sPartCode)
    
    Call AddLoadField(FID_INVENTORY_PartCode)
    Call AddLoadField(FID_INVENTORY_QuantityAtHand)
    Call AddLoadField(FID_INVENTORY_QuantityOnOrder)
    Call AddLoadField(FID_INVENTORY_LastOrdered)
    
    Call LoadMatches

    If blnOrdered = True Then mQuantityOnOrder = mQuantityOnOrder - dblReceivedQuantity
    mQuantityAtHand = mQuantityAtHand + dblReceivedQuantity
    mLastReceived = dteDelNoteDate

    'Save updated fields back to Database
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    Call oRow.Add(GetField(FID_INVENTORY_PartCode))
    Call oRow.Add(GetField(FID_INVENTORY_QuantityAtHand))
    If blnOrdered = True Then Call oRow.Add(GetField(FID_INVENTORY_QuantityOnOrder))
    Call oRow.Add(GetField(FID_INVENTORY_LastOrdered))

    Call m_oSession.Database.SavePartialBo(Me, oRow)
    Set oRow = Nothing

End Sub 'RecordItemReceived

'<CACH>****************************************************************************************
'* Sub:  RecordItemSold()
'**********************************************************************************************
'* Description: Business rule called by Stock Log.  Used to updates information on
'*              Stock Master showing Quantity on Stock On Hand.
'**********************************************************************************************
'* Parameters:
'*In/Out:sPartCode  String. - Unique Part Code used to load in Item if not already loaded
'*In/Out:dblQuantitySold   Double. - actual quantity sold to lower Quantity on hand
'**********************************************************************************************
'* History:
'* 08/11/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Sub RecordItemSold(strPartCode As String, dblQuantitySold As Double)

Dim oRow As IRow
            
    If mPartCode <> strPartCode Then
        Call AddLoadFilter(CMP_EQUAL, FID_INVENTORY_PartCode, strPartCode)
        
        Call AddLoadField(FID_INVENTORY_PartCode)
        Call AddLoadField(FID_INVENTORY_QuantityAtHand)
        
        Call LoadMatches
    End If
    mQuantityAtHand = mQuantityAtHand + dblQuantitySold

    'Save updated fields back to Database
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    Call oRow.Add(GetField(FID_INVENTORY_PartCode))
    Call oRow.Add(GetField(FID_INVENTORY_QuantityAtHand))

    Call m_oSession.Database.SavePartialBo(Me, oRow)
    Set oRow = Nothing

End Sub 'RecordItemSold

'<CACH>****************************************************************************************
'* Sub:  RecordItemRefunded()
'**********************************************************************************************
'* Description: Business rule called by Stock Log.  Used to updates information on
'*              Stock Master showing Quantity on Stock On Hand.
'**********************************************************************************************
'* Parameters:
'*In/Out:sPartCode  String. - Unique Part Code used to load in Item if not already loaded
'*In/Out:dblQuantityRefunded Double. - actual quantity sold to increase Quantity on hand
'**********************************************************************************************
'* History:
'* 08/11/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Sub RecordItemRefunded(strPartCode As String, dblQuantityRefunded As Double)

Dim oRow As IRow
            
    If mPartCode <> strPartCode Then
        Call AddLoadFilter(CMP_EQUAL, FID_INVENTORY_PartCode, strPartCode)
        
        Call AddLoadField(FID_INVENTORY_PartCode)
        Call AddLoadField(FID_INVENTORY_QuantityAtHand)
        
        Call LoadMatches
    End If
    mQuantityAtHand = mQuantityAtHand + dblQuantityRefunded

    'Save updated fields back to Database
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    Call oRow.Add(GetField(FID_INVENTORY_PartCode))
    Call oRow.Add(GetField(FID_INVENTORY_QuantityAtHand))

    Call m_oSession.Database.SavePartialBo(Me, oRow)
    Set oRow = Nothing

End Sub 'RecordItemRefunded

'<CACH>****************************************************************************************
'* Sub:  RecordAdjustment()
'**********************************************************************************************
'* Description: Business rule called by Stock Log.  Used to updates information on
'*              Stock Master showing Quantity on Stock On Hand.
'**********************************************************************************************
'* Parameters:
'*In/Out:sPartCode  String. - Unique Part Code used to load in Item if not already loaded
'*In/Out:dblAdjustmentQuantity   Double. - actual quantity adjusted to apply to Quantity on hand
'**********************************************************************************************
'* History:
'* 08/11/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Sub RecordAdjustment(sPartCode As String, dblAdjustmentQuantity As Double)

Dim oRow As IRow
            
    If mPartCode <> sPartCode Then
        Call AddLoadFilter(CMP_EQUAL, FID_INVENTORY_PartCode, sPartCode)
        
        Call AddLoadField(FID_INVENTORY_PartCode)
        Call AddLoadField(FID_INVENTORY_QuantityAtHand)
        
        Call LoadMatches
    End If
    mQuantityAtHand = mQuantityAtHand + dblAdjustmentQuantity

    'Save updated fields back to Database
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    Call oRow.Add(GetField(FID_INVENTORY_PartCode))
    Call oRow.Add(GetField(FID_INVENTORY_QuantityAtHand))

    Call m_oSession.Database.SavePartialBo(Me, oRow)
    Set oRow = Nothing

End Sub 'RecordAdjustment

'<CACH>****************************************************************************************
'* Sub:  RecordItemReturned()
'**********************************************************************************************
'* Description: Business rule called by Supplier Return Line.  Used to update information on
'*              Stock Master showing Quantity on Stock On Hand.
'**********************************************************************************************
'* Parameters:
'*In/Out:sPartCode  String. - Unique Part Code used to load in Item if not already loaded
'*In/Out:dblReturnedQuantity  Double. - actaul quantity returned- subtracted from quantity on hand
'**********************************************************************************************
'* History:
'* 08/11/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Sub RecordItemReturned(sPartCode As String, dblReturnedQuantity As Double)

Dim oRow As IRow
            
    If mPartCode <> sPartCode Then
        Call AddLoadFilter(CMP_EQUAL, FID_INVENTORY_PartCode, sPartCode)
        
        Call AddLoadField(FID_INVENTORY_PartCode)
        Call AddLoadField(FID_INVENTORY_QuantityAtHand)
        
        Call LoadMatches
    End If
    mQuantityAtHand = mQuantityAtHand + dblReturnedQuantity

    'Save updated fields back to Database
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    Call oRow.Add(GetField(FID_INVENTORY_PartCode))
    Call oRow.Add(GetField(FID_INVENTORY_QuantityAtHand))

    Call m_oSession.Database.SavePartialBo(Me, oRow)
    Set oRow = Nothing

End Sub 'RecordItemReturned

'<CACH>****************************************************************************************
'* Sub:  RecordISTItemReceived()
'**********************************************************************************************
'* Description: Business rule called by Delivery Note Line.  Used to updates information on
'*              Stock Master showing Quantity on Stock On Hand with date received and reducing
'*              Stock on order
'**********************************************************************************************
'* Parameters:
'*In/Out:sPartCode  String. - Unique Part Code used to load in Item if not already loaded
'*In/Out:dblReceivedQuantity   Double. - actaul quantity received- added to quantity on hand
'**********************************************************************************************
'* History:
'* 08/11/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Sub RecordISTItemReceived(sPartCode As String, dblReceivedQuantity As Double)

Dim oRow As IRow
            
    If mPartCode <> sPartCode Then
        Call AddLoadFilter(CMP_EQUAL, FID_INVENTORY_PartCode, sPartCode)
        
        Call AddLoadField(FID_INVENTORY_PartCode)
        Call AddLoadField(FID_INVENTORY_QuantityAtHand)
        
        Call LoadMatches
    End If
    mQuantityAtHand = mQuantityAtHand + dblReceivedQuantity

    'Save updated fields back to Database
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    Call oRow.Add(GetField(FID_INVENTORY_PartCode))
    Call oRow.Add(GetField(FID_INVENTORY_QuantityAtHand))

    Call m_oSession.Database.SavePartialBo(Me, oRow)
    Set oRow = Nothing

End Sub 'RecordISTItemReceived

'<CACH>****************************************************************************************
'* Sub:  RecordISTItemIssued()
'**********************************************************************************************
'* Description: Business rule called by Delivery Note Line.  Used to updates information on
'*              Stock Master showing Quantity on Stock On Hand with date received and reducing
'*              Stock on order
'**********************************************************************************************
'* Parameters:
'*In/Out:sPartCode  String. - Unique Part Code used to load in Item if not already loaded
'*In/Out:dblIssuedQuantity   Double. - actual quantity received(neg) added to quantity on hand
'**********************************************************************************************
'* History:
'* 08/11/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Sub RecordISTItemIssued(sPartCode As String, dblIssuedQuantity As Double)

Dim oRow As IRow
            
    If mPartCode <> sPartCode Then
        Call AddLoadFilter(CMP_EQUAL, FID_INVENTORY_PartCode, sPartCode)
        
        Call AddLoadField(FID_INVENTORY_PartCode)
        Call AddLoadField(FID_INVENTORY_QuantityAtHand)
        
        Call LoadMatches
    End If
    mQuantityAtHand = mQuantityAtHand + dblIssuedQuantity

    'Save updated fields back to Database
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    Call oRow.Add(GetField(FID_INVENTORY_PartCode))
    Call oRow.Add(GetField(FID_INVENTORY_QuantityAtHand))

    Call m_oSession.Database.SavePartialBo(Me, oRow)
    Set oRow = Nothing

End Sub 'RecordISTItemIssued

Private Function GetAllFieldsAsRow() As IRow
' Returns a CRow object containing one field object for each property.
    
Dim oRow    As IRow
Dim nFid    As Long
    
    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    For nFid = (CLASSID_INVENTORY * &H10000) + 1 To FID_INVENTORY_END_OF_STATIC Step 1
        oRow.Add GetField(nFid)
    Next nFid
    Set GetAllFieldsAsRow = oRow

End Function




'<CACH>****************************************************************************************
'* Function:  Boolean IBo_AddLoadFilter()
'**********************************************************************************************
'* Description: Part of the IBo Interface.  Used to set-up any selection criteria before
'*              calling the IBo_Load method.  This appends the selection criteria to the
'*              oRowSel object which is used by the IBo_Load method.
'**********************************************************************************************
'* Parameters:
'*In/Out:Comparator Long. - Comparison Type - see modBO.bas
'*In/Out:FieldID    Long. - Unique Field ID against which field to compare against
'*In/Out:Value  Variant. - Value that Field will be compared to
'**********************************************************************************************
'* Returns:  Boolean - True if Valid FieldID and successful
'**********************************************************************************************
'* History:
'* 08/10/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Function IBo_AddLoadFilter(Comparator As Long, FieldID As Long, Value As Variant) As Boolean
    IBo_AddLoadFilter = AddLoadFilter(Comparator, FieldID, Value)
End Function
Public Function AddLoadFilter(Comparator As Long, FieldID As Long, Value As Variant) As Boolean

Dim oField As IField

Const PROCEDURE_NAME As String = MODULE_NAME & ".AddLoadFilter"

    'Create field for storing Key into
    Set oField = GetField(FieldID)
    If oField Is Nothing Then Exit Function
    oField.ValueAsVariant = Value
    
    'Add field to Row selector
    If moRowSel Is Nothing Then Set moRowSel = m_oSession.Root.CreateUtilityObject("CRowSelector")
    Call moRowSel.AddSelection(Comparator, oField)
    AddLoadFilter = True

End Function 'AddLoadFilter




'<CACH>****************************************************************************************
'* Function:  Boolean IBo_AddLoadField()
'**********************************************************************************************
'* Description: Part of the IBo Interface.  Used to set-up all fields that must be returned
'*              when using the LoadMatches method.  This appends the field to the oFieldRow
'*              object which is used by the IBo_LoadMatches method, if it is populated.
'**********************************************************************************************
'* Parameters:
'*In/Out:FieldID    Long. - Unique Field ID against which field to compare against
'**********************************************************************************************
'* History:
'* 09/10/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Sub IBo_AddLoadField(FieldID As Long)
    AddLoadField FieldID
End Sub

Public Sub AddLoadField(FieldID As Long)

Const PROCEDURE_NAME As String = MODULE_NAME & ".AddLoadField"
    
    'Add field to Row selector
    If moLoadRow Is Nothing Then Set moLoadRow = m_oSession.Root.CreateUtilityObject("CRowSelector")
    Call moLoadRow.AddSelectAll(FieldID)

End Sub      'AddLoadField

Public Sub IBo_ClearLoadFilter()

    Set moRowSel = Nothing

End Sub

Public Sub IBo_ClearLoadField()

    Set moLoadRow = Nothing

End Sub

Public Function IBo_LoadMatches(Optional oReturnRow As IRow = Nothing) As Collection
    Set IBo_LoadMatches = LoadMatches(oReturnRow)
End Function

Public Function LoadMatches(Optional oReturnRow As IRow = Nothing) As Collection

' Load up all properties from the database
Dim oView       As IView
Dim colBO       As Collection
Dim oBO         As ISysBo
Dim lBONo       As Long
Dim oLoadFields As IRowSelector
    
    Set colBO = New Collection
    
    Call CheckIsUnInitialised(m_oSession, IBo_ClassName)
    
    Set oLoadFields = moRowSel
    If oLoadFields Is Nothing Then Set oLoadFields = m_oSession.Root.CreateUtilityObject("CRowSelector")
    
    If oReturnRow Is Nothing Then
        If moLoadRow Is Nothing Then
            Call oLoadFields.Merge(GetSelectAllRow)
        Else
            Call oLoadFields.Merge(moLoadRow) ' add in the specified field
        End If
    Else
        Call oLoadFields.Merge(oReturnRow) ' add in the specified field
    End If
    
    ' Pass the selector to the database to get the data view
    Set oView = m_oSession.Database.GetView(oLoadFields)
    If Not (oView Is Nothing) Then
        For lBONo = 1 To oView.Count Step 1
            Set oBO = m_oSession.Database.CreateBusinessObject(IBo_ClassId)
            Call oBO.LoadFromRow(oView.Row(CLng(lBONo)))
            If lBONo = 1 Then Call LoadFromRow(oView.Row(CLng(1)))
            Call colBO.Add(oBO)
        Next lBONo
    End If
    
    Set LoadMatches = colBO

End Function

Public Function IBo_Interface(Optional eInterfaceType As Long) As IBo
    Set IBo_Interface = Interface(eInterfaceType)
End Function

Public Function IBo_GetAllFieldsAsRow() As IRow
        
    Set IBo_GetAllFieldsAsRow = GetAllFieldsAsRow()

End Function

Public Function IBo_EndOfStaticFieldId() As Long

    IBo_EndOfStaticFieldId = FID_INVENTORY_END_OF_STATIC

End Function

Public Function GetSelectSQL() As String

Dim oRSelector  As IRowSelector
Dim nFid        As Long
Dim oView       As IView
Dim lRowNo      As Long
Dim intFieldNo  As Integer
    
    Call CheckIsUnInitialised(m_oSession, IBo_ClassName)
'    If lenb(lId) <> 0 Then mPartCode = sId
    
    Set oRSelector = m_oSession.Root.CreateUtilityObject("CRowSelector")
    'Add in selector first to overide the ALL's
    
    Call oRSelector.AddSelectAll(FID_INVENTORY_PartCode)
    Call oRSelector.AddSelectAll(FID_INVENTORY_Description)
    
    If Not moRowSel Is Nothing Then
        For intFieldNo = 1 To moRowSel.Count Step 1
            Call oRSelector.AddSelection(moRowSel.FieldSelector(intFieldNo).Comparator, moRowSel.FieldSelector(intFieldNo).Field.Interface)
        Next intFieldNo
    End If
    
    'Set mcolPartCode = New Collection
    ' Pass the selector to the database to get the data view
    GetSelectSQL = m_oSession.Database.GetSelectView(moLoadRow, oRSelector)

End Function

Friend Function ApplyPriceChange(strPartCode As String, curNewPrice As Currency, _
                dteEffectiveDate As Date, ByRef curPriceDiff As Currency, _
                ByRef strStatus As String, ByRef strEventNo As String, _
                ByRef strPriority As String, ByRef blnAutoApplied As Boolean)

Dim oRow As IRow
Dim oStockLogBO As cStockLog

    'Get latest values for Stock Item
    Call AddLoadFilter(CMP_EQUAL, FID_INVENTORY_PartCode, strPartCode)
    Call AddLoadField(FID_INVENTORY_PartCode)
    Call AddLoadField(FID_INVENTORY_NormalSellPrice)
    Call AddLoadField(FID_INVENTORY_PriorSellPrice)
    Call AddLoadField(FID_INVENTORY_PriceEffectiveDate)
    Call AddLoadField(FID_INVENTORY_QuantityAtHand)
    Call AddLoadField(FID_INVENTORY_UnitsInOpenReturns)
    Call AddLoadField(FID_INVENTORY_MarkDownQuantity)
    Call AddLoadField(FID_INVENTORY_WriteOffQuantity)
    
    Call LoadMatches

    Set oRow = m_oSession.Root.CreateUtilityObject("CRow")
    Call oRow.Add(GetField(FID_INVENTORY_PartCode))
    If (blnAutoApplied = False) Then
        'calculate differences and update stock item
        curPriceDiff = curNewPrice - mNormalSellPrice
        mPriorSellPrice = mNormalSellPrice
        mNormalSellPrice = curNewPrice
        mPriceEffectiveDate = dteEffectiveDate
        'Save updated fields back to Database
        Call oRow.Add(GetField(FID_INVENTORY_NormalSellPrice))
        Call oRow.Add(GetField(FID_INVENTORY_PriorSellPrice))
        Call oRow.Add(GetField(FID_INVENTORY_PriceEffectiveDate))
    End If
    mRetailPriceEventNo = strEventNo
    mRetailPricePriority = strPriority
    Call oRow.Add(GetField(FID_INVENTORY_RetailPriceEventNo))
    Call oRow.Add(GetField(FID_INVENTORY_RetailPricePriority))

    Call m_oSession.Database.SavePartialBo(Me, oRow)
    
    If (blnAutoApplied = False) Then
        'Create Stock Log entry to reflect price change
        Set oStockLogBO = m_oSession.Database.CreateBusinessObject(CLASSID_STOCKLOG)
        oStockLogBO.LogDate = Date
        oStockLogBO.LogTime = Format(Now, "HHNNSS")
        oStockLogBO.PartCode = mPartCode
        oStockLogBO.StartStockQty = mQuantityAtHand
        oStockLogBO.EndStockQty = mQuantityAtHand
        oStockLogBO.StartMarkDownSOH = mMarkDownQuantity
        oStockLogBO.EndMarkDownSOH = mMarkDownQuantity
        oStockLogBO.StartOpenReturnQty = mUnitsInOpenReturns
        oStockLogBO.EndOpenReturnQty = mUnitsInOpenReturns
        oStockLogBO.TransactionKey = mPartCode & "     " & Format(mPriceEffectiveDate, "dd/mm/yy") & "  " & strStatus
        oStockLogBO.DayNumber = CLng(Date) - 1
        oStockLogBO.StartPrice = mPriorSellPrice
        oStockLogBO.EndPrice = mNormalSellPrice
        ApplyPriceChange = oStockLogBO.SavePriceChange
    End If
    Set oRow = Nothing

End Function
    

